package main

import (
	"flag"
	"strings"
)

// Created so that multiple inputs can be accecpted
type arrayFlags struct {
	strs *[]string
}

func flagStrings(name, usage string) arrayFlags {
	f := arrayFlags{new([]string)}
	flag.Var(&f, name, usage)
	return f
}

func (i arrayFlags) String() string {
	if i.strs == nil {
		return ""
	}
	return strings.Join(*i.strs, ", ")
}

func (i arrayFlags) Set(value string) error {
	*i.strs = append(*i.strs, strings.TrimSpace(value))
	return nil
}
